//
// THIS FILE IS COPYRIGHT 1994, 1995 BY TELENOR RESEARCH, NORWAY
//
//                        ALL RIGHTS RESERVED.
//
// For rights granted to the public see the COPYRIGHT file
//
//
// div.cc	Various utility routines
//
// Author:  Ken Ronny Schouten
//
// Changes: 950128 Brd Hfjeld
//				Added strncmp8
//
#include <stdlib.h>
#include <string.h>
#include <stream.h>

int strcmp8(unsigned const char *s1, unsigned const char *s2)
{
    int i = 0;
    int len1 = strlen((char *)s1);
    int len2 = strlen((char *)s2);

    while (len1 > i && len2 > i) {
	unsigned char c = s1[i];
	unsigned char s = s2[i];
	if (c-s != 0) {
	    return c-s;
	}
	i++;
    }
    if (len1 < len2) {
	return -1;
    }
    else if (len1 == len2) {
	return 0;
    }
    else {
	return 1;
    }

    return 0;
}

int strncmp8(unsigned const char *s1, unsigned const char *s2, int length)
{
    int i = 0;
    int len1 = strlen((char *)s1);
    int len2 = strlen((char *)s2);

    while (len1 > i && len2 > i && i<length) {
	unsigned char c = s1[i];
	unsigned char s = s2[i];
	if (c-s != 0) {
	    return c-s;
	}
	i++;
    }

    if ( i == length ) return 0;
    
    if (len1 < len2) {
	return -1;
    }
    else if (len1 == len2) {
	return 0;
    }
    else {
	return 1;
    }

    return 0;
}

void addEscapeCode(unsigned char *s) 
{
    unsigned char *num, *str;
    if ((num = (unsigned char *) strstr((char *) s,"|")) == NULL)
	return;
    
    int count = 1;
    num++;
    while ((num = (unsigned char *) strstr((char *) num,"|"))
	   != NULL) {
	count++;
	num++;	
    }

    unsigned char bar[] = "/BAR_CODE/";
    int len = strlen((char *) bar);
    int lens = strlen((char *) s);
    int size = 1 + lens +(len*count);
    str = (unsigned char *) malloc(sizeof(char) * size);
		       
    int i,x;
    for(i = 0, x = 0; i < lens; i++, x++) {
	if (s[i] != '|') {
	    str[x] = s[i];
	} else {
	    str = (unsigned char *) strcat((char *) str, (char *) bar);
	    x = x + len - 1;
	}
    }
    str[x] = '\0';

    s = str;
}
